#!/bin/bash -x
trap "shutdown -h now" ERR

yum -y update
yum -y upgrade

rpm -i CollabNetSubversion-client-1.5.6-1.i386.rpm

# Install EC2 API tools
wget http://s3.amazonaws.com/ec2-downloads/ec2-api-tools-1.3-30349.zip
unzip ec2-api-tools-1.3-30349.zip
mv ec2-api-tools-1.3-30349 /usr/local/ec2/ec2-api-tools

# JDK 1.6
wget "http://download.java.net/dlj/binaries/jdk-6u11-dlj-linux-i586.bin"
mkdir unbundle-jdk-6
cd unbundle-jdk-6
sh ../jdk-6u11-dlj-linux-i586.bin --accept-license
cd ..

# JDK 1.5
wget "http://download.java.net/dlj/binaries/jdk-5.0u17-dlj-linux-i586.bin"
mkdir unbundle-jdk-5
cd unbundle-jdk-5
sh ../jdk-5.0u17-dlj-linux-i586.bin --accept-license
cd ..

# Build the JDKs
wget -O construct.sh "https://jdk-distros.dev.java.net/source/browse/*checkout*/jdk-distros/trunk/utils/construct.sh?content-type=text%2Fplain&rev=148" --no-check-certificate
sh construct.sh unbundle-jdk-6 /opt/jdk-6 /opt/jre-6
sh construct.sh unbundle-jdk-5 /opt/jdk-5 /opt/jre-5

# Maven 2
wget "http://www.apache.org/dist/maven/binaries/apache-maven-2.0.10-bin.tar.bz2"
tar xjC /opt -f apache-maven-2.0.10-bin.tar.bz2
mv /opt/apache-maven-2.0.10 /opt/maven-2.0
ln -fs /opt/maven-2.0 /opt/apache-maven-2.0.9

# Maven 2.1
wget "http://archive.apache.org/dist/maven/binaries/apache-maven-2.1.0-bin.tar.bz2"
tar xjC /opt -f apache-maven-2.1.0-bin.tar.bz2
mv /opt/apache-maven-2.1.0 /opt/maven-2.1
ln -fs /opt/maven-2.1 /opt/apache-maven-2.1.0


# Maven 1.1
wget "http://archive.apache.org/dist/maven/binaries/maven-1.1.tar.bz2"
tar xjC /opt -f maven-1.1.tar.bz2

# Maven 1.0.2 (with patched optional Ant jar to allow forkmode once)
tar xzC /opt -f maven-1.0.2.tar.gz

# Ant
wget "http://www.apache.org/dist/ant/binaries/apache-ant-1.7.1-bin.tar.bz2"
tar xjC /opt -f apache-ant-1.7.1-bin.tar.bz2

#Grails
wget "http://dist.codehaus.org/grails/grails-1.3.1.zip"
unzip grails-1.3.1.zip

wget "http://dist.codehaus.org/grails/grails-1.2.2.zip"
unzip grails-1.2.2.zip

# Bamboo
useradd bamboo
tar xzC /opt -f bamboo-elastic-agent-$2.tar.gz
ln -s bamboo-elastic-agent-$2 /opt/bamboo-elastic-agent

# Default Maven repository TODO This will most likely be removed.
# tar xzC /home/bamboo -f maven1-repo.tar.gz
# chown -R bamboo:bamboo /home/bamboo/.maven

# tar xvzC /home/bamboo -f mvn-repository.tar.gz
# chown -R bamboo:bamboo /home/bamboo/.m2

# Custom capabilities
mv bamboo-capabilities.properties /home/bamboo/

# Correct permissions
chown -R bamboo:bamboo /home/bamboo/

# Environment
mv profile.sh /etc/profile.d/bamboo.sh
cat rc.local >> /etc/rc.d/rc.local

echo $3 >> motd
mv motd /etc/motd
rm -f /root/firstlogin /etc/ssh/ssh_host_da_key /etc/ssh/ssh_host_dsa_key.pub /etc/ssh/ssh_host_key /etc/ssh/ssh_host_key.pub /etc/ssh/ssh_host_rsa_key /etc/ssh/ssh_host_rsa_key.pub /root/.ssh/authorized_keys
touch /root/firstrun

# Bundle it
ec2-bundle-vol -c cert.pem -k pk.pem -u $4 -p elasticbamboo-$3 --batch --debug
ec2-upload-bundle -b $5 -m /tmp/elasticbamboo-$3.manifest.xml -a $6 -s $1 --retry --debug

shutdown -h now